library XmlParserDll;

uses
  SysUtils,
  Dialogs,
  ActiveX,
  XMLDoc,
  XMLIntf,
  Variants;

type
  TWideCharArray = array [0..MaxInt div 2 -1] of WideChar;
  PWideCharArray = ^TWideCharArray;

const N=6;

function GetCode(xml:PWideChar; code:PWideChar): boolean; stdcall;
var
  i : integer;
  x : IXMLDocument;
  procedure Add(s:WideString);
  var j : integer;
  begin
    for j:=1 to Length(s) do begin
      PWideCharArray(code)^[i]:=s[j];
      Inc(i);
    end;
  end;
  procedure AddText(aText:WideString);
  var k : integer; s:WideString;
  begin
    s:=IntToStr(Length(aText));
    for k:=1 to N-Length(s) do Add('0');
    Add(s);
    Add(aText);
  end;
  procedure AddAttribute(attr:IXMLNode);
  begin
    Add('A');
    AddText(attr.NodeName);
    if attr.NodeValue<>Null then AddText(attr.NodeValue) else AddText('');
  end;
  procedure AddElement(node:IXMLNode);
  var k : integer;
  begin
    Add('N');
    AddText(node.NodeName);
    for k:=0 to node.AttributeNodes.Count-1 do
      if node.AttributeNodes[k].NodeType=ntAttribute then
        AddAttribute(node.AttributeNodes[k]);
    for k:=0 to node.ChildNodes.Count-1 do
      if node.ChildNodes[k].NodeType=ntElement then
        AddElement(node.ChildNodes[k]);
    if (node.IsTextElement) then begin
      Add('T');
      AddText(node.Text);
    end;
    Add('D');
  end;
begin
  CoInitialize(nil);
  x := NewXMLDocument;
  x.Options:=x.Options-[doAttrNull];
  try
    try
      x.LoadFromXml(xml);
      i:=Low(TWideCharArray);
      AddElement(x.DocumentElement);
      result:=true;
    except
      on E:Exception do begin
        i:=0;
        Add('Error:'+E.Message+WideChar(0));
        result:=False;
      end;
    end;
  finally
//    xml:=nil;
    CoUninitialize;
  end;
end;

exports
  GetCode;

begin
end.
